%% Gradienti funzioni

% Pesi
[~,~,wv] = Phi_array(s); % array con le funzioni di snervamento Phis = [Phi_1,...,Phi_Ns];, dove Ns è il numero totale di meccanismi
dPsis = grad_matrix(s);
grad = dPsis*wv';

%% Gradiente numerico dei pesi

dSigma = 1e-5;
[~,~,wv_sx_plus] = Phi_array(s + [dSigma;0;0]);
[~,~,wv_sy_plus] = Phi_array(s + [0;dSigma;0]);
[~,~,wv_txy_plus] = Phi_array(s + [0;0;dSigma]);
[~,~,wv_sx_minus] = Phi_array(s - [dSigma;0;0]);
[~,~,wv_sy_minus] = Phi_array(s - [0;dSigma;0]);
[~,~,wv_txy_minus] = Phi_array(s - [0;0;dSigma;]);
wv_der(1,:) = (wv_sx_plus - wv_sx_minus)/(2*dSigma);
wv_der(2,:) = (wv_sy_plus - wv_sy_minus)/(2*dSigma);
wv_der(3,:) = (wv_txy_plus - wv_txy_minus)/(2*dSigma);

%% Funzione calcolo matrice dei gradienti analitici

function dPsis = grad_matrix(s)

    sx = s(1);
    sy = s(2);
    txy = s(3);

    % Phi_CDP
    psi = 10; % dilatanza in gradi
    epsilon = 0.1; % eccentricità 
    grad_CDP = [tand(psi)/3 + 0.5*(2*sx - sy)/(sqrt((epsilon*sigma_t*tand(material.par1))^2 + sx^2 + sy^2 - sx*sy + 3*txy^2));...
                tand(psi)/3 + 0.5*(2*sy - sx)/(sqrt((epsilon*sigma_t*tand(material.par1))^2 + sx^2 + sy^2 - sx*sy + 3*txy^2));...
                0.5*(6*txy)/(sqrt((epsilon*sigma_t*tand(psi))^2 + sx^2 + sy^2 - sx*sy + 3*txy^2))];
    % Phi_h_h
    if Phi_h_h_ass % qua inserire un flag per decidere se legge associata o non associata
    % Associated
    grad_G_h_h = [0;mi;(txy/(abs(txy) + 1e-6))];%/(material.par2 + 1e-3);
    else
    % Non associata
    grad_G_h_h = [0;0;(txy/((abs(txy) + 1e-6)))];
    end

    % Phi_h_v
    % Associata
    grad_G_h_v = [0;1;0];
    
    % Phi_d_h
    if Phi_d_h_ass
    % Associata
    grad_G_d_h = [(2*h_b/l_b);material.par1;txy/abs(txy + 1e-6) + (2*h_b/l_b)*material.par1*txy/abs(txy + 1e-6)];%/(material.par2 + (2*material.par4/material.par6)*material.par3 + 1e-3);
    else
    % Non associata
    grad_G_d_h = [1;0;(txy/abs(txy + 1e-6))];
    end

    % Phi_d_v
    if Phi_d_v_ass
    % Associata
    grad_G_d_v = [mi;(l_b/(2*h_b));txy/abs(txy + 1e-6) + (l_b/(2*h_b))*mi*txy/abs(txy + 1e-6)];
    else
    % Non associata
    grad_G_d_v = [0;1;txy/abs(txy + 1e-6)];
    end
    
    % Phi_v 
    if Phi_v_ass
    % Associata
    grad_G_v = [1;(f*l_b/(2*h_b))*mi;0];
    else
    % Non associata
    grad_G_v = [1; 0;0];
    end
    
    % Phi_mixed
    psi_mixed = 2; % dilatanza del meccanismo misto
    grad_G_mixed = [tand(psi_mixed);0;txy/(abs(txy) + 1e-6)];
    
    dPsis = [grad_CDP, grad_G_h_h, grad_G_h_v, grad_G_d_h, grad_G_d_v, grad_G_v, grad_G_mixed]; % matrice dei gradienti: 3xNs
end


